## opendht 1.3.5

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.6)
project (opendht)
set (opendht_VERSION_MAJOR 1)
set (opendht_VERSION_MINOR 3.5)
set (opendht_VERSION ${opendht_VERSION_MAJOR}.${opendht_VERSION_MINOR})
set (PACKAGE_VERSION ${opendht_VERSION})
set (VERSION "${opendht_VERSION}")

list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")

include(GNUInstallDirs)
set (prefix ${CMAKE_INSTALL_PREFIX})
set (exec_prefix "\${prefix}")
set (libdir "\${exec_prefix}/${CMAKE_INSTALL_LIBDIR}")
set (includedir "\${prefix}/${CMAKE_INSTALL_INCLUDEDIR}")
set (bindir "${CMAKE_INSTALL_FULL_BINDIR}")
set (sysconfdir "${CMAKE_INSTALL_FULL_SYSCONFDIR}")

option (OPENDHT_STATIC "Build static library" ON)
option (OPENDHT_SHARED "Build shared library" ON)
option (OPENDHT_LOG "Build with logs" ON)
option (OPENDHT_PYTHON "Build Python bindings" OFF)
option (OPENDHT_TOOLS "Build DHT tools" ON)
option (OPENDHT_SYSTEMD "Install systemd module" OFF)
option (OPENDHT_ARGON2 "Use included argon2 sources" OFF)
option (OPENDHT_LTO "Build with LTO" OFF)

find_package (GnuTLS 3.3 REQUIRED)
find_package (Msgpack 1.2 REQUIRED)
if (OPENDHT_TOOLS)
    find_package (Readline 6 REQUIRED)
endif ()
if (NOT OPENDHT_ARGON2)
    find_package(PkgConfig)
    pkg_search_module(argon2 libargon2)
    if (argon2_FOUND)
        message("Argon2 found " ${argon2_req})
        set(argon2_lib ", libargon2")
    else ()
        message("Argon2 not found, using included version.")
        set(OPENDHT_ARGON2 ON)
    endif()
endif ()

set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pthread -std=c++11 -Wno-return-type -Wall -Wextra -Wnon-virtual-dtor -pedantic-errors -fvisibility=hidden")
set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DMSGPACK_DISABLE_LEGACY_NIL -DMSGPACK_DISABLE_LEGACY_CONVERT")
if (NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release)
endif ()
if (OPENDHT_LOG)
    add_definitions(-DOPENDHT_LOG=true)
else ()
    add_definitions(-DOPENDHT_LOG=false)
endif()
if (OPENDHT_LTO)
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -flto")
    if (CMAKE_COMPILER_IS_GNUCC)
        set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fuse-linker-plugin")
        set (CMAKE_AR        "gcc-ar")
        set (CMAKE_NM        "gcc-nm")
        set (CMAKE_RANLIB    "gcc-ranlib")
    endif ()
endif ()

list (APPEND opendht_SOURCES
    src/utils.cpp
    src/infohash.cpp
    src/crypto.cpp
    src/default_types.cpp
    src/node.cpp
    src/value.cpp
    src/dht.cpp
    src/storage.h
    src/listener.h
    src/search.h
    src/request.h
    src/callbacks.cpp
    src/routing_table.cpp
    src/node_cache.cpp
    src/network_engine.cpp
    src/securedht.cpp
    src/dhtrunner.cpp
    src/indexation/pht.cpp
    src/log.cpp
)

list (APPEND opendht_HEADERS
    include/opendht/def.h
    include/opendht/utils.h
    include/opendht/sockaddr.h
    include/opendht/rng.h
    include/opendht/crypto.h
    include/opendht/infohash.h
    include/opendht/default_types.h
    include/opendht/node.h
    include/opendht/value.h
    include/opendht/dht.h
    include/opendht/callbacks.h
    include/opendht/routing_table.h
    include/opendht/node_cache.h
    include/opendht/network_engine.h
    include/opendht/net.h
    include/opendht/scheduler.h
    include/opendht/rate_limiter.h
    include/opendht/securedht.h
    include/opendht/log.h
    include/opendht/log_enable.h
    include/opendht.h
    include/opendht/indexation/pht.h
)

configure_file (
    opendht.pc.in
    opendht.pc
    @ONLY
)

include_directories(
    ./
    include/
    include/opendht/
    ${CMAKE_CURRENT_BINARY_DIR}/include/
)
if(OPENDHT_ARGON2)
    # make sure argon2 submodule is up to date and initialized
    message("Initializing Argon2 submodule")
    execute_process(COMMAND git submodule update --init)

    # add local argon2 files to build
    list (APPEND opendht_SOURCES
        argon2/src/argon2.c
        argon2/src/core.c
        argon2/src/blake2/blake2b.c
        argon2/src/thread.c
        argon2/src/ref.c
        argon2/src/encoding.c
    )
    include_directories(argon2/include/)
endif()

if (OPENDHT_STATIC)
    add_library (opendht-static STATIC
        ${opendht_SOURCES}
        ${opendht_HEADERS}
    )
    set_target_properties (opendht-static PROPERTIES OUTPUT_NAME "opendht")
    if (OPENDHT_LTO)
        target_link_libraries(opendht-static -flto -fuse-linker-plugin)
    endif ()
    if (OPENDHT_ARGON2)
        target_include_directories(opendht-static SYSTEM PRIVATE argon2)
    else ()
        target_link_libraries(opendht-static ${argon2_LIBRARIES})
        target_include_directories(opendht-static SYSTEM PRIVATE ${argon2_INCLUDE_DIRS})
    endif ()
    target_link_libraries(opendht-static gnutls nettle)
    install (TARGETS opendht-static DESTINATION ${CMAKE_INSTALL_LIBDIR} EXPORT opendht)
endif ()

if (OPENDHT_SHARED)
    add_library (opendht SHARED
        ${opendht_SOURCES}
        ${opendht_HEADERS}
    )
    set_target_properties (opendht PROPERTIES IMPORT_SUFFIX "_import.lib")
    set_target_properties (opendht PROPERTIES SOVERSION ${opendht_VERSION_MAJOR} VERSION ${opendht_VERSION})
    target_compile_definitions(opendht PRIVATE OPENDHT_BUILD)
    if (OPENDHT_LTO)
        target_link_libraries(opendht -flto -fuse-linker-plugin)
    endif ()
    if (OPENDHT_ARGON2)
        target_include_directories(opendht SYSTEM PRIVATE argon2)
    else ()
        target_link_libraries(opendht ${argon2_LIBRARIES})
        target_include_directories(opendht SYSTEM PRIVATE ${argon2_INCLUDE_DIRS})
    endif ()
    target_link_libraries(opendht gnutls nettle)
    install (TARGETS opendht DESTINATION ${CMAKE_INSTALL_LIBDIR} EXPORT opendht)
endif ()

if (OPENDHT_TOOLS)
    add_subdirectory(tools)
endif ()
add_subdirectory(doc)

if (OPENDHT_PYTHON)
    add_subdirectory(python)
endif ()

include(CMakePackageConfigHelpers)
write_basic_package_version_file("${CMAKE_CURRENT_BINARY_DIR}/opendhtConfigVersion.cmake"
  VERSION ${opendht_VERSION}
  COMPATIBILITY AnyNewerVersion
)
install (DIRECTORY include DESTINATION ${CMAKE_INSTALL_PREFIX})
install (FILES ${CMAKE_CURRENT_BINARY_DIR}/opendht.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
install (EXPORT opendht DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/opendht FILE opendhtConfig.cmake)
install (FILES ${CMAKE_CURRENT_BINARY_DIR}/opendhtConfigVersion.cmake DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/opendht)

## opendht 1.2.1~dfsg1

=== debian/changelog ===
opendht (1.2.1~dfsg1-8) unstable; urgency=medium

  * dev package: Add library dependencies (Closes: #849561).

 -- Alexandre Viau <aviau@debian.org>  Wed, 28 Dec 2016 17:11:11 -0500

opendht (1.2.1~dfsg1-7) unstable; urgency=medium

  [ Alexandre Viau ]
  * Import Gianfranco's work (Closes: #843788).

  [ Gianfranco Costamagna ]
  * Multiarchify the package.

 -- Alexandre Viau <aviau@debian.org>  Wed, 09 Nov 2016 11:28:54 -0500

opendht (1.2.1~dfsg1-6) unstable; urgency=medium

  * libopendht-dev now breaks+replaces libopendht1 (Closes: #843680)

 -- Alexandre Viau <aviau@debian.org>  Tue, 08 Nov 2016 13:13:44 -0500

opendht (1.2.1~dfsg1-5) unstable; urgency=medium

  * Don't ship libopendht1. Debian policy allows for shipping
    only static libraries since OpenDHT's API is not stable
    enough.

 -- Alexandre Viau <aviau@debian.org>  Mon, 07 Nov 2016 13:14:31 -0500

opendht (1.2.1~dfsg1-4) unstable; urgency=medium

  * Add libopendht.shlibs.

 -- Alexandre Viau <aviau@debian.org>  Sat, 05 Nov 2016 01:00:46 -0400

opendht (1.2.1~dfsg1-3) unstable; urgency=medium

  * Remove pkg-kde-tools dependency.

 -- Alexandre Viau <aviau@debian.org>  Fri, 04 Nov 2016 16:10:56 -0400

opendht (1.2.1~dfsg1-2) unstable; urgency=medium

  * Link against argon2.

 -- Alexandre Viau <aviau@debian.org>  Fri, 04 Nov 2016 03:29:16 -0400

opendht (1.2.1~dfsg1-1) unstable; urgency=medium

  * Remove symbols file.
  * Refresh use-debian-argon2.patch.
  * Remove build_versioned_shared_library.patch.
  * Use manpage from source.

 -- Alexandre Viau <aviau@debian.org>  Wed, 29 Jun 2016 15:52:22 +0200

opendht (0.6.1~dfsg1-1) experimental; urgency=medium

  * Initial release. (Closes: #809362)

 -- Alexandre Viau <aviau@debian.org>  Mon, 27 Jun 2016 13:09:11 +0200

=== debian/control ===
Source: opendht
Section: libs
Priority: extra
Maintainer: Alexandre Viau <aviau@debian.org>
Build-Depends: debhelper (>= 9),
               cmake,
               libgnutls28-dev,
               libmsgpack-dev (>= 1.2),
               libreadline6-dev,
               libncurses5-dev,
               libargon2-0-dev
Standards-Version: 3.9.8
Homepage: https://github.com/savoirfairelinux/opendht
Vcs-Git: https://anonscm.debian.org/git/collab-maint/opendht.git
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/opendht.git

Package: libopendht-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends},
         libgnutls28-dev,
         libmsgpack-dev (>= 1.2),
         libreadline6-dev,
         libncurses5-dev,
         libargon2-0-dev
Provides: libopendht-dev
Breaks: libopendht1 (<< 1.2.1~dfsg1-6)
Replaces: libopendht1 (<< 1.2.1~dfsg1-6)
Multi-Arch: same
Description: Development files for the libopendht library
 OpenDHT is a C++11 distributed hash table implementation.
 Feature list:
  - Distributed shared key->value data-store
  - Clean and powerful distributed map API with storage of
    arbitrary binary values of up to 56 KB.
  - Optional public key cryptography layer providing data
    signature and encryption (using GnuTLS).
  - IPv4 and IPv6 support.
  - Python bindings.
 .
 This package contains the static library and headers.

Package: dhtnode
Architecture: any
Section: net
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: OpenDHT node binary
 OpenDHT is a C++11 distributed hash table implementation.
 Feature list:
  - Distributed shared key->value data-store
  - Clean and powerful distributed map API with storage of
    arbitrary binary values of up to 56 KB.
  - Optional public key cryptography layer providing data
    signature and encryption (using GnuTLS).
  - IPv4 and IPv6 support.
  - Python bindings.
 .
 This package contains the OpenDHT node binary.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Hardening
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

CONFIGURE_FLAGS += -DOPENDHT_STATIC=ON
CONFIGURE_FLAGS += -DOPENDHT_SHARED=OFF
CONFIGURE_FLAGS += -DCMAKE_POSITION_INDEPENDENT_CODE=ON

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- ${CONFIGURE_FLAGS}

## opendht 1.3.5

=== debian/changelog ===
opendht (1.3.5-1) unstable; urgency=medium

  * New upstream snapshot.

 -- Alexandre Viau <aviau@debian.org>  Wed, 02 Aug 2017 15:41:36 -0400

opendht (1.3.4-3) unstable; urgency=medium

  * Remove unneeded multiarch.patch.

 -- Alexandre Viau <aviau@debian.org>  Sun, 02 Jul 2017 14:35:50 -0400

opendht (1.3.4-2) unstable; urgency=medium

  * dhtnode.service: restart on-failure

 -- Alexandre Viau <aviau@debian.org>  Sat, 01 Jul 2017 15:20:42 -0400

opendht (1.3.4-1) unstable; urgency=medium

  * New upstream snapshot.
  * dhtnode: include systemd service.

 -- Alexandre Viau <aviau@debian.org>  Sat, 01 Jul 2017 14:51:02 -0400

opendht (1.3.3-2) unstable; urgency=medium

  * Install CMakeFiles. (Closes: #866586)

 -- Alexandre Viau <aviau@debian.org>  Fri, 30 Jun 2017 16:03:24 -0400

opendht (1.3.3-1) unstable; urgency=medium

  * New upstream snapshot. (Closes: #866078)
  * Refresh patches.
  * Remove use-debian-argon2.patch.
  * Remove python bindings mention.
  * Bump Standards-Version to 4.0.0.
  * Build-Depend on pkg-config.

 -- Alexandre Viau <aviau@debian.org>  Tue, 27 Jun 2017 18:42:38 -0400

=== debian/control ===
--- 
+++ 
@@ -4,12 +4,15 @@
 Maintainer: Alexandre Viau <aviau@debian.org>
 Build-Depends: debhelper (>= 9),
                cmake,
+               dh-systemd,
+               dh-exec,
+               pkg-config,
                libgnutls28-dev,
                libmsgpack-dev (>= 1.2),
                libreadline6-dev,
                libncurses5-dev,
                libargon2-0-dev
-Standards-Version: 3.9.8
+Standards-Version: 4.0.0
 Homepage: https://github.com/savoirfairelinux/opendht
 Vcs-Git: https://anonscm.debian.org/git/collab-maint/opendht.git
 Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/opendht.git
@@ -36,7 +39,6 @@
   - Optional public key cryptography layer providing data
     signature and encryption (using GnuTLS).
   - IPv4 and IPv6 support.
-  - Python bindings.
  .
  This package contains the static library and headers.
 
@@ -44,7 +46,8 @@
 Architecture: any
 Section: net
 Depends: ${misc:Depends},
-         ${shlibs:Depends}
+         ${shlibs:Depends},
+         adduser
 Description: OpenDHT node binary
  OpenDHT is a C++11 distributed hash table implementation.
  Feature list:
@@ -54,6 +57,5 @@
   - Optional public key cryptography layer providing data
     signature and encryption (using GnuTLS).
   - IPv4 and IPv6 support.
-  - Python bindings.
  .
  This package contains the OpenDHT node binary.

## opendht 1.5.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,21 +1,12 @@
-cmake_minimum_required (VERSION 2.8.6)
+cmake_minimum_required (VERSION 3.1)
 project (opendht)
 set (opendht_VERSION_MAJOR 1)
-set (opendht_VERSION_MINOR 3.5)
+set (opendht_VERSION_MINOR 5.0)
 set (opendht_VERSION ${opendht_VERSION_MAJOR}.${opendht_VERSION_MINOR})
 set (PACKAGE_VERSION ${opendht_VERSION})
 set (VERSION "${opendht_VERSION}")
 
-list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")
-
-include(GNUInstallDirs)
-set (prefix ${CMAKE_INSTALL_PREFIX})
-set (exec_prefix "\${prefix}")
-set (libdir "\${exec_prefix}/${CMAKE_INSTALL_LIBDIR}")
-set (includedir "\${prefix}/${CMAKE_INSTALL_INCLUDEDIR}")
-set (bindir "${CMAKE_INSTALL_FULL_BINDIR}")
-set (sysconfdir "${CMAKE_INSTALL_FULL_SYSCONFDIR}")
-
+# Options
 option (OPENDHT_STATIC "Build static library" ON)
 option (OPENDHT_SHARED "Build shared library" ON)
 option (OPENDHT_LOG "Build with logs" ON)
@@ -24,8 +15,20 @@
 option (OPENDHT_SYSTEMD "Install systemd module" OFF)
 option (OPENDHT_ARGON2 "Use included argon2 sources" OFF)
 option (OPENDHT_LTO "Build with LTO" OFF)
-
+option (OPENDHT_SANITIZE "Build with address sanitizer and stack protector" OFF)
+option (OPENDHT_PROXY_SERVER "Enable DHT proxy server, use Restbed and jsoncpp" OFF)
+option (OPENDHT_PROXY_SERVER_IDENTITY "Allow clients to use the node identity" OFF)
+option (OPENDHT_PROXY_CLIENT "Enable DHT proxy client, use Restbed and jsoncpp" OFF)
+
+find_package(Doxygen)
+option (OPENDHT_DOCUMENTATION "Create and install the HTML based API documentation (requires Doxygen)" ${DOXYGEN_FOUND})
+
+# Dependencies
+list (APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")
+find_package (Threads)
+find_package (PkgConfig)
 find_package (GnuTLS 3.3 REQUIRED)
+pkg_search_module (Nettle nettle)
 find_package (Msgpack 1.2 REQUIRED)
 if (OPENDHT_TOOLS)
     find_package (Readline 6 REQUIRED)
@@ -41,8 +44,18 @@
         set(OPENDHT_ARGON2 ON)
     endif()
 endif ()
-
-set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pthread -std=c++11 -Wno-return-type -Wall -Wextra -Wnon-virtual-dtor -pedantic-errors -fvisibility=hidden")
+if (OPENDHT_PROXY_SERVER OR OPENDHT_PROXY_CLIENT)
+    find_package(Restbed REQUIRED)
+    pkg_search_module(Jsoncpp jsoncpp)
+endif()
+
+# Build flags
+set (CMAKE_CXX_STANDARD 11)
+set (CMAKE_CXX_STANDARD_REQUIRED on)
+set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-return-type -Wall -Wextra -Wnon-virtual-dtor -pedantic-errors -fvisibility=hidden")
+if (OPENDHT_SANITIZE)
+    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address -fstack-protector-strong")
+endif ()
 set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DMSGPACK_DISABLE_LEGACY_NIL -DMSGPACK_DISABLE_LEGACY_CONVERT")
 if (NOT CMAKE_BUILD_TYPE)
     set(CMAKE_BUILD_TYPE Release)
@@ -62,6 +75,41 @@
     endif ()
 endif ()
 
+if (MSGPACK_INCLUDE_DIRS)
+    include_directories (SYSTEM "${MSGPACK_INCLUDE_DIRS}")
+endif ()
+if (GNUTLS_INCLUDE_DIRS)
+    include_directories (SYSTEM "${GNUTLS_INCLUDE_DIRS}")
+endif ()
+if (Nettle_INCLUDE_DIRS)
+    include_directories (SYSTEM "${Nettle_INCLUDE_DIRS}")
+endif ()
+if (RESTBED_INCLUDE)
+    include_directories (SYSTEM "${RESTBED_INCLUDE}")
+endif ()
+if (Jsoncpp_INCLUDE_DIRS)
+    include_directories (SYSTEM "${Jsoncpp_INCLUDE_DIRS}")
+endif ()
+link_directories (${Nettle_LIBRARY_DIRS})
+link_directories (${Jsoncpp_LIBRARY_DIRS})
+include_directories (
+    ./
+    include/
+    include/opendht/
+    ${CMAKE_CURRENT_BINARY_DIR}/include/
+)
+
+# Install dirs
+include (GNUInstallDirs)
+set (prefix ${CMAKE_INSTALL_PREFIX})
+set (exec_prefix "\${prefix}")
+set (libdir "\${exec_prefix}/${CMAKE_INSTALL_LIBDIR}")
+set (includedir "\${prefix}/${CMAKE_INSTALL_INCLUDEDIR}")
+set (bindir "${CMAKE_INSTALL_FULL_BINDIR}")
+set (sysconfdir "${CMAKE_INSTALL_FULL_SYSCONFDIR}")
+set (top_srcdir "${CMAKE_CURRENT_SOURCE_DIR}")
+
+# Sources
 list (APPEND opendht_SOURCES
     src/utils.cpp
     src/infohash.cpp
@@ -73,6 +121,8 @@
     src/storage.h
     src/listener.h
     src/search.h
+    src/net.h
+    src/parsed_message.h
     src/request.h
     src/callbacks.cpp
     src/routing_table.cpp
@@ -99,7 +149,6 @@
     include/opendht/routing_table.h
     include/opendht/node_cache.h
     include/opendht/network_engine.h
-    include/opendht/net.h
     include/opendht/scheduler.h
     include/opendht/rate_limiter.h
     include/opendht/securedht.h
@@ -109,18 +158,25 @@
     include/opendht/indexation/pht.h
 )
 
-configure_file (
-    opendht.pc.in
-    opendht.pc
-    @ONLY
-)
-
-include_directories(
-    ./
-    include/
-    include/opendht/
-    ${CMAKE_CURRENT_BINARY_DIR}/include/
-)
+if (OPENDHT_PROXY_SERVER)
+  add_definitions(-DOPENDHT_PROXY_SERVER=true)
+  if (OPENDHT_PROXY_SERVER_IDENTITY)
+    add_definitions(-DOPENDHT_PROXY_SERVER_IDENTITY=true)
+  else ()
+    add_definitions(-DOPENDHT_PROXY_SERVER_IDENTITY=false)
+  endif()
+  list (APPEND opendht_HEADERS
+    include/opendht/dht_proxy_server.h
+  )
+  list (APPEND opendht_SOURCES
+    src/dht_proxy_server.cpp
+    src/base64.h
+    src/base64.cpp
+  )
+else ()
+    add_definitions(-DENABLE_PROXY_SERVER=false)
+endif ()
+
 if(OPENDHT_ARGON2)
     # make sure argon2 submodule is up to date and initialized
     message("Initializing Argon2 submodule")
@@ -138,6 +194,7 @@
     include_directories(argon2/include/)
 endif()
 
+# Targets
 if (OPENDHT_STATIC)
     add_library (opendht-static STATIC
         ${opendht_SOURCES}
@@ -153,7 +210,7 @@
         target_link_libraries(opendht-static ${argon2_LIBRARIES})
         target_include_directories(opendht-static SYSTEM PRIVATE ${argon2_INCLUDE_DIRS})
     endif ()
-    target_link_libraries(opendht-static gnutls nettle)
+    target_link_libraries(opendht-static ${CMAKE_THREAD_LIBS_INIT} ${GNUTLS_LIBRARIES} ${Nettle_LIBRARIES} ${Restbed_LIBRARIES} ${Jsoncpp_LIBRARIES})
     install (TARGETS opendht-static DESTINATION ${CMAKE_INSTALL_LIBDIR} EXPORT opendht)
 endif ()
 
@@ -166,15 +223,15 @@
     set_target_properties (opendht PROPERTIES SOVERSION ${opendht_VERSION_MAJOR} VERSION ${opendht_VERSION})
     target_compile_definitions(opendht PRIVATE OPENDHT_BUILD)
     if (OPENDHT_LTO)
-        target_link_libraries(opendht -flto -fuse-linker-plugin)
+        target_link_libraries(opendht PRIVATE -flto -fuse-linker-plugin)
     endif ()
     if (OPENDHT_ARGON2)
         target_include_directories(opendht SYSTEM PRIVATE argon2)
     else ()
-        target_link_libraries(opendht ${argon2_LIBRARIES})
+        target_link_libraries(opendht PRIVATE ${argon2_LIBRARIES})
         target_include_directories(opendht SYSTEM PRIVATE ${argon2_INCLUDE_DIRS})
     endif ()
-    target_link_libraries(opendht gnutls nettle)
+    target_link_libraries(opendht PRIVATE ${CMAKE_THREAD_LIBS_INIT} ${GNUTLS_LIBRARIES} ${Nettle_LIBRARIES} ${Restbed_LIBRARIES} ${Jsoncpp_LIBRARIES})
     install (TARGETS opendht DESTINATION ${CMAKE_INSTALL_LIBDIR} EXPORT opendht)
 endif ()
 
@@ -187,11 +244,20 @@
     add_subdirectory(python)
 endif ()
 
+# CMake module
 include(CMakePackageConfigHelpers)
 write_basic_package_version_file("${CMAKE_CURRENT_BINARY_DIR}/opendhtConfigVersion.cmake"
   VERSION ${opendht_VERSION}
   COMPATIBILITY AnyNewerVersion
 )
+# PkgConfig module
+configure_file (
+    opendht.pc.in
+    opendht.pc
+    @ONLY
+)
+
+# Install targets
 install (DIRECTORY include DESTINATION ${CMAKE_INSTALL_PREFIX})
 install (FILES ${CMAKE_CURRENT_BINARY_DIR}/opendht.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
 install (EXPORT opendht DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/opendht FILE opendhtConfig.cmake)

=== debian/changelog ===
opendht (1.5.0-2~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Alexandre Viau <aviau@debian.org>  Mon, 29 Jan 2018 21:22:43 +0000

opendht (1.5.0-2) unstable; urgency=medium

  * Move to salsa.debian.org.

 -- Alexandre Viau <aviau@debian.org>  Thu, 28 Dec 2017 17:09:51 -0500

opendht (1.5.0-1) unstable; urgency=medium

  * New upstream snapshot.

 -- Alexandre Viau <aviau@debian.org>  Thu, 23 Nov 2017 19:44:27 -0500

opendht (1.4.1-1) unstable; urgency=medium

  * New upstream snapshot.
  * Use msgpack v1 API.

 -- Alexandre Viau <aviau@debian.org>  Wed, 15 Nov 2017 20:54:42 -0500

opendht (1.3.6-1) unstable; urgency=medium

  * New upstream snapshot.

 -- Alexandre Viau <aviau@debian.org>  Fri, 25 Aug 2017 16:44:04 -0400

=== debian/rules ===
--- 
+++ 
@@ -6,12 +6,18 @@
 DPKG_EXPORT_BUILDFLAGS = 1
 include /usr/share/dpkg/buildflags.mk
 
+# This has to be in sync with ring.
+export DEB_CXXFLAGS_MAINT_APPEND = -DMSGPACK_DEFAULT_API_VERSION=1
+
 CONFIGURE_FLAGS += -DOPENDHT_STATIC=ON
 CONFIGURE_FLAGS += -DOPENDHT_SHARED=OFF
 CONFIGURE_FLAGS += -DCMAKE_POSITION_INDEPENDENT_CODE=ON
 
 %:
-	dh $@
+	dh $@ --with=systemd
 
 override_dh_auto_configure:
 	dh_auto_configure -- ${CONFIGURE_FLAGS}
+
+override_dh_installinit:
+	echo override_dh_installinit

=== debian/watch ===
version=3
opts=\
filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/opendht-$1\.tar\.gz/,\
repacksuffix=~dfsg1,\
dversionmangle=s/\~dfsg\d*$// \
  https://github.com/savoirfairelinux/opendht/tags .*/v?(\d\S*)\.tar\.gz

## opendht 1.6.0

=== debian/changelog ===
opendht (1.6.0-1) unstable; urgency=medium

  * d/watch: exclude release candidates.
  * d/copyright: fix insecure-copyright-format-uri.

 -- Alexandre Viau <aviau@debian.org>  Tue, 27 Feb 2018 06:11:11 +0000

opendht (1.5.0-3) unstable; urgency=medium

  * Build with msgpack-c v2 API.

 -- Alexandre Viau <aviau@debian.org>  Thu, 01 Feb 2018 17:47:24 +0000

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,9 @@
 Source: opendht
 Section: libs
-Priority: extra
+Priority: optional
 Maintainer: Alexandre Viau <aviau@debian.org>
-Build-Depends: debhelper (>= 9),
+Build-Depends: debhelper (>= 9.20160709),
                cmake,
-               dh-systemd,
                dh-exec,
                pkg-config,
                libgnutls28-dev,
@@ -14,8 +13,8 @@
                libargon2-0-dev
 Standards-Version: 4.0.0
 Homepage: https://github.com/savoirfairelinux/opendht
-Vcs-Git: https://anonscm.debian.org/git/collab-maint/opendht.git
-Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/opendht.git
+Vcs-Git: https://salsa.debian.org/debian/opendht.git
+Vcs-Browser: https://salsa.debian.org/debian/opendht
 
 Package: libopendht-dev
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -5,9 +5,6 @@
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 DPKG_EXPORT_BUILDFLAGS = 1
 include /usr/share/dpkg/buildflags.mk
-
-# This has to be in sync with ring.
-export DEB_CXXFLAGS_MAINT_APPEND = -DMSGPACK_DEFAULT_API_VERSION=1
 
 CONFIGURE_FLAGS += -DOPENDHT_STATIC=ON
 CONFIGURE_FLAGS += -DOPENDHT_SHARED=OFF

## opendht 1.7.4

=== debian/changelog ===
opendht (1.7.4-1) unstable; urgency=medium

  * New upstream version.

 -- Alexandre Viau <aviau@debian.org>  Sat, 18 Aug 2018 15:51:19 -0400

opendht (1.7.2-1) unstable; urgency=medium

  * New upstream version.
  * Fix maintainer-script-should-not-use-recursive-chown-or-chmod.

 -- Alexandre Viau <aviau@debian.org>  Tue, 26 Jun 2018 18:08:36 -0400

## opendht 1.7.4-1%2B8.0trisquel1

=== debian/changelog ===
opendht (1.7.4-1+8.0trisquel1) flidas; urgency=medium

  * Backported from cosmic

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Tue, 09 Oct 2018 02:49:42 +0000

## opendht 1.8.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 cmake_minimum_required (VERSION 3.1)
 project (opendht)
 set (opendht_VERSION_MAJOR 1)
-set (opendht_VERSION_MINOR 5.0)
+set (opendht_VERSION_MINOR 8.1)
 set (opendht_VERSION ${opendht_VERSION_MAJOR}.${opendht_VERSION_MINOR})
 set (PACKAGE_VERSION ${opendht_VERSION})
 set (VERSION "${opendht_VERSION}")
@@ -17,8 +17,11 @@
 option (OPENDHT_LTO "Build with LTO" OFF)
 option (OPENDHT_SANITIZE "Build with address sanitizer and stack protector" OFF)
 option (OPENDHT_PROXY_SERVER "Enable DHT proxy server, use Restbed and jsoncpp" OFF)
+option (OPENDHT_PUSH_NOTIFICATIONS "Enable push notifications support" OFF)
 option (OPENDHT_PROXY_SERVER_IDENTITY "Allow clients to use the node identity" OFF)
 option (OPENDHT_PROXY_CLIENT "Enable DHT proxy client, use Restbed and jsoncpp" OFF)
+option (OPENDHT_INDEX "Build DHT indexation feature" OFF)
+option (OPENDHT_TESTS "Add unit tests executable" OFF)
 
 find_package(Doxygen)
 option (OPENDHT_DOCUMENTATION "Create and install the HTML based API documentation (requires Doxygen)" ${DOXYGEN_FOUND})
@@ -44,9 +47,21 @@
         set(OPENDHT_ARGON2 ON)
     endif()
 endif ()
+
+pkg_search_module(Jsoncpp jsoncpp)
+if (Jsoncpp_FOUND)
+    add_definitions(-DOPENDHT_JSONCPP)
+    list (APPEND opendht_SOURCES
+      src/base64.h
+      src/base64.cpp
+    )
+endif()
+
 if (OPENDHT_PROXY_SERVER OR OPENDHT_PROXY_CLIENT)
     find_package(Restbed REQUIRED)
-    pkg_search_module(Jsoncpp jsoncpp)
+    if (NOT Jsoncpp_FOUND)
+        message(SEND_ERROR "Jsoncpp is required for DHT proxy support")
+    endif()
 endif()
 
 # Build flags
@@ -84,8 +99,8 @@
 if (Nettle_INCLUDE_DIRS)
     include_directories (SYSTEM "${Nettle_INCLUDE_DIRS}")
 endif ()
-if (RESTBED_INCLUDE)
-    include_directories (SYSTEM "${RESTBED_INCLUDE}")
+if (Restbed_INCLUDE_DIR)
+    include_directories (SYSTEM "${Restbed_INCLUDE_DIR}")
 endif ()
 if (Jsoncpp_INCLUDE_DIRS)
     include_directories (SYSTEM "${Jsoncpp_INCLUDE_DIRS}")
@@ -118,9 +133,12 @@
     src/node.cpp
     src/value.cpp
     src/dht.cpp
+    src/op_cache.cpp
     src/storage.h
     src/listener.h
     src/search.h
+    src/value_cache.h
+    src/op_cache.h
     src/net.h
     src/parsed_message.h
     src/request.h
@@ -130,7 +148,6 @@
     src/network_engine.cpp
     src/securedht.cpp
     src/dhtrunner.cpp
-    src/indexation/pht.cpp
     src/log.cpp
 )
 
@@ -145,6 +162,7 @@
     include/opendht/node.h
     include/opendht/value.h
     include/opendht/dht.h
+    include/opendht/dht_interface.h
     include/opendht/callbacks.h
     include/opendht/routing_table.h
     include/opendht/node_cache.h
@@ -155,8 +173,13 @@
     include/opendht/log.h
     include/opendht/log_enable.h
     include/opendht.h
-    include/opendht/indexation/pht.h
-)
+)
+
+if (OPENDHT_INDEX)
+    list (APPEND opendht_SOURCES src/indexation/pht.cpp)
+    list (APPEND opendht_HEADERS include/opendht/indexation/pht.h)
+    add_definitions(-DOPENDHT_INDEXATION)
+endif()
 
 if (OPENDHT_PROXY_SERVER)
   add_definitions(-DOPENDHT_PROXY_SERVER=true)
@@ -170,11 +193,33 @@
   )
   list (APPEND opendht_SOURCES
     src/dht_proxy_server.cpp
-    src/base64.h
-    src/base64.cpp
   )
 else ()
     add_definitions(-DENABLE_PROXY_SERVER=false)
+endif ()
+
+if (OPENDHT_PROXY_CLIENT)
+  add_definitions(-DOPENDHT_PROXY_CLIENT=true)
+  list (APPEND opendht_HEADERS
+    include/opendht/dht_proxy_client.h
+  )
+  list (APPEND opendht_SOURCES
+    src/dht_proxy_client.cpp
+  )
+else ()
+  add_definitions(-DOPENDHT_PROXY_CLIENT=false)
+endif ()
+
+if (OPENDHT_PROXY_SERVER OR OPENDHT_PROXY_CLIENT)
+  if (OPENDHT_PUSH_NOTIFICATIONS)
+    message("Using push notification")
+    add_definitions(-DOPENDHT_PUSH_NOTIFICATIONS=true)
+  else ()
+    add_definitions(-DOPENDHT_PUSH_NOTIFICATIONS=false)
+  endif ()
+  list (APPEND opendht_HEADERS
+    include/opendht/proxy.h
+  )
 endif ()
 
 if(OPENDHT_ARGON2)
@@ -201,16 +246,14 @@
         ${opendht_HEADERS}
     )
     set_target_properties (opendht-static PROPERTIES OUTPUT_NAME "opendht")
-    if (OPENDHT_LTO)
-        target_link_libraries(opendht-static -flto -fuse-linker-plugin)
-    endif ()
     if (OPENDHT_ARGON2)
         target_include_directories(opendht-static SYSTEM PRIVATE argon2)
     else ()
-        target_link_libraries(opendht-static ${argon2_LIBRARIES})
         target_include_directories(opendht-static SYSTEM PRIVATE ${argon2_INCLUDE_DIRS})
     endif ()
-    target_link_libraries(opendht-static ${CMAKE_THREAD_LIBS_INIT} ${GNUTLS_LIBRARIES} ${Nettle_LIBRARIES} ${Restbed_LIBRARIES} ${Jsoncpp_LIBRARIES})
+    target_link_libraries(opendht-static
+        PRIVATE ${Restbed_LIBRARY} ${argon2_LIBRARIES}
+        PUBLIC ${CMAKE_THREAD_LIBS_INIT} ${GNUTLS_LIBRARIES} ${Nettle_LIBRARIES} ${Jsoncpp_LIBRARIES})
     install (TARGETS opendht-static DESTINATION ${CMAKE_INSTALL_LIBDIR} EXPORT opendht)
 endif ()
 
@@ -222,16 +265,13 @@
     set_target_properties (opendht PROPERTIES IMPORT_SUFFIX "_import.lib")
     set_target_properties (opendht PROPERTIES SOVERSION ${opendht_VERSION_MAJOR} VERSION ${opendht_VERSION})
     target_compile_definitions(opendht PRIVATE OPENDHT_BUILD)
-    if (OPENDHT_LTO)
-        target_link_libraries(opendht PRIVATE -flto -fuse-linker-plugin)
-    endif ()
     if (OPENDHT_ARGON2)
         target_include_directories(opendht SYSTEM PRIVATE argon2)
     else ()
         target_link_libraries(opendht PRIVATE ${argon2_LIBRARIES})
         target_include_directories(opendht SYSTEM PRIVATE ${argon2_INCLUDE_DIRS})
     endif ()
-    target_link_libraries(opendht PRIVATE ${CMAKE_THREAD_LIBS_INIT} ${GNUTLS_LIBRARIES} ${Nettle_LIBRARIES} ${Restbed_LIBRARIES} ${Jsoncpp_LIBRARIES})
+    target_link_libraries(opendht PRIVATE ${CMAKE_THREAD_LIBS_INIT} ${GNUTLS_LIBRARIES} ${Nettle_LIBRARIES} ${Restbed_LIBRARY} ${Jsoncpp_LIBRARIES})
     install (TARGETS opendht DESTINATION ${CMAKE_INSTALL_LIBDIR} EXPORT opendht)
 endif ()
 
@@ -262,3 +302,39 @@
 install (FILES ${CMAKE_CURRENT_BINARY_DIR}/opendht.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
 install (EXPORT opendht DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/opendht FILE opendhtConfig.cmake)
 install (FILES ${CMAKE_CURRENT_BINARY_DIR}/opendhtConfigVersion.cmake DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/opendht)
+
+# Unit tests
+IF(OPENDHT_TESTS)
+  FIND_PACKAGE(Cppunit REQUIRED)
+  # unit testing
+    list (APPEND test_FILES
+      tests/infohashtester.h
+      tests/infohashtester.cpp
+      tests/cryptotester.h
+      tests/cryptotester.cpp
+      tests/dhtrunnertester.h
+      tests/dhtrunnertester.cpp
+    )
+    if (OPENDHT_PROXY_SERVER AND OPENDHT_PROXY_CLIENT)
+      list (APPEND test_FILES
+        tests/dhtproxytester.h
+        tests/dhtproxytester.cpp
+      )
+    endif()
+    add_executable(opendht_unit_tests
+      tests/tests_runner.cpp
+      ${test_FILES}
+    )
+    if (OPENDHT_SHARED)
+      TARGET_LINK_LIBRARIES(opendht_unit_tests opendht)
+    else ()
+      TARGET_LINK_LIBRARIES(opendht_unit_tests opendht-static)
+    endif ()
+    TARGET_LINK_LIBRARIES(opendht_unit_tests
+       ${CMAKE_THREAD_LIBS_INIT}
+       ${CPPUNIT_LIBRARIES}
+       ${GNUTLS_LIBRARIES}
+    )
+    enable_testing()
+    add_test(TEST opendht_unit_tests)
+ENDIF()

=== debian/changelog ===
opendht (1.8.1-1build3) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:21:52 +0100

opendht (1.8.1-1build2) focal; urgency=medium

  * No-change rebuild against libnettle7

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 31 Oct 2019 22:13:34 +0000

opendht (1.8.1-1build1) disco; urgency=medium

  * No-change rebuild for readline soname change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 14 Jan 2019 19:52:00 +0000

opendht (1.8.1-1) unstable; urgency=medium

  * New upstream version.

 -- Alexandre Viau <aviau@debian.org>  Sat, 05 Jan 2019 21:57:00 -0500

opendht (1.8.0-1) unstable; urgency=medium

  * New upstream version.

 -- Alexandre Viau <aviau@debian.org>  Mon, 10 Dec 2018 20:15:28 -0500

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: opendht
 Section: libs
 Priority: optional
-Maintainer: Alexandre Viau <aviau@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Alexandre Viau <aviau@debian.org>
 Build-Depends: debhelper (>= 9.20160709),
                cmake,
                dh-exec,

## opendht 1.8.1-1build3%2B9.0trisquel1

=== debian/changelog ===
opendht (1.8.1-1build3+9.0trisquel1) etiona; urgency=medium

  * Backported from focal

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Fri, 19 Jun 2020 23:22:47 +0000

## opendht 2.1.6

=== debian/changelog ===
opendht (2.1.6-1) unstable; urgency=medium

  [ Amin Bandali ]
  * New upstream version.
  * Enable OpenDHT proxy features.

  [ Alexandre Viau ]
  * Rules-Requires-Root: no.

 -- Alexandre Viau <aviau@debian.org>  Sat, 10 Oct 2020 16:35:04 -0400

opendht (2.1.4-1) unstable; urgency=medium

  * New upstream version.
  * dhtnode.conf: remove -v. (Closes: #959226)

 -- Alexandre Viau <aviau@debian.org>  Sat, 15 Aug 2020 12:42:20 -0400

opendht (2.1.1-1) unstable; urgency=medium

  * New upstream version.
  * Depend on librestinio-dev, libasio-dev.
  * Refresh patches.

 -- Alexandre Viau <aviau@debian.org>  Sat, 16 May 2020 13:08:04 -0400

=== debian/rules ===
--- 
+++ 
@@ -9,6 +9,9 @@
 CONFIGURE_FLAGS += -DOPENDHT_STATIC=ON
 CONFIGURE_FLAGS += -DOPENDHT_SHARED=OFF
 CONFIGURE_FLAGS += -DCMAKE_POSITION_INDEPENDENT_CODE=ON
+CONFIGURE_FLAGS += -DOPENDHT_PROXY_SERVER=ON
+CONFIGURE_FLAGS += -DOPENDHT_PROXY_CLIENT=ON
+CONFIGURE_FLAGS += -DOPENDHT_PUSH_NOTIFICATIONS=ON
 
 %:
 	dh $@ --with=systemd
